
\ ********************************* ANSI TERMINAL SUPPORT ******************

:  black	0 ;
:  red		1 ;
:  green	2 ;
:  yellow	3 ;
:  blue	4 ;t
:  magenta	5 ;
:  cyan	6 ;
:  white	7 ;

: .DEC		BASE C@ >L DECIMAL <# # # #> .STR L> BASE C! ;
: ESC ( ch -- ) $1B EMIT EMIT ;
: ESCB ( ch -- ) $5B ESC EMIT ;
: ESCH ( ch -- ) $23 ESC EMIT ;
: DHT		"3" ESCH ;
: DHB		"4" ESCH ;
: NARROW	"5" ESCH ;
: WIDE		"6" ESCH ;
: CUR ( cmd n -- ) $5B ESC .DEC EMIT ;
: XY	( x y -- ) $5B ESC .DEC ." ;" .DEC "H" EMIT ;
: FG ( col -- ) $33 ESCB $30 + EMIT $6D EMIT ;
: BG ( col -- ) $34 ESCB $30 + EMIT $6D EMIT ;


: HOME		$48 ESCB ; 
: ERSCN	"2" ESCB "J" EMIT ;
: ERLINE	"2" ESCB "K" EMIT ;
: CLS		HOME ERSCN ;

: CUROFF	"?" ESCB ." 25l" ;
: ATR ( ch -- ) ESCB "m" EMIT ;
: PLAIN	$30 ATR ;
: REVERSE	$37 ATR ;
: BOLD		$31 ATR ;
: MARGINS ( top bottom -- ) $5B ESC SWAP .DEC ";" EMIT .DEC "r" EMIT ;
: HORZ ( n -- )  FOR $C4 EMIT NEXT ;
: HLINE ( x y n -- ) >L XY L> HORZ ;
: VERT ( n -- ) FOR $B3 EMIT $0A EMIT $08 EMIT NEXT ;
: VLINE ( x y n -- ) >L XY L> VERT ;
: BOX ( x y w h -- ) 
	4 ITEMS


pub box (x,y,w,h)
' top line
  xy(x,y)      ' to top left
  vtx($da)     ' top left corner
  horz(w-2)    ' top line 
  vtx($bf)     ' top right corner
' bottom line
  xy(x,y+h)    ' to bottom left
  vtx($c0)     ' bottom left corner
  horz(w-2)    ' bottom line
' left side
  xy(x,y+1)    ' to left side below corner
  vert(h-1)    ' left side
' right side
  xy(x+w,y+1)
  vert(h-1)
  vtx($d9)     ' bottom right cornet

#endif
